// Smartmeter Momentanleistung aus Wirkenergie Bezug +A Total errechnen
// und im lokalen WEB darstellen.
// Zusaetzlich das Energie Tagesprofiel speichern (fuer EXCEL)
// (c)Peter Klingbeil 03/2022 (film-werk56.de)
// UpDate SD-Karte Test anzeigen 15-03-22
// Eine Kommerzielle Nutzung ist nur mit meiner Zustimmung erlaubt.

#include <stdlib.h>
#include <SD.h>
#include <Wire.h>
#include <WiFi.h>
#include <SSD1306.h> //OLED 64*128 display headers

SSD1306 display(0x3c, 21,22); // Display Pins

#define RXD2 25      // Seriell Input optische Info-/MSB-Schnittstelle
#define TXD2 19      // nicht benutzt

/*
 *  SD card attached to SPI bus for ESP32:
 ** MOSI - Pin 23
 ** MISO - Pin 19
 ** CLK -  Pin 18
 ** CS -   Pin 5 
 */
 
#define SD_CS 5      // SD Card select

int DigOut=12;       // Aktivitaets LED Digitalausgang 12

unsigned char inByte = 0; // Ir Data
unsigned char Data[300];  // Ir Data 16 Bit
unsigned char Value[5] = {0x30,0x30,0x30,0x30,0x00}; //Vorbelegung
unsigned char Z;  // fuer Umrechnung Hex/Dez
char Val[9];      // Wirkleistung 8 Bytes + NULL
unsigned long KWH = 0, KWHalt = 0, KWHakku = 0, ZW1 = 0;    // Leistungswerte
unsigned long Power = 0, P = 0;  // Wirkleistung aktuell
volatile unsigned long Time=0, Time2=0, DTime=0;  // Messzeit
volatile int Counter = 0; // Pointer Ir Data Array
volatile int Test=0, Test2=0; // Schreibe Datei alle x Sekunden

int Zyklus=0;  // Mittelwert Bildung
int SML = 0;   // SML Anzahl Startbytes
byte Start = 0; // Warte auf Daten
struct tm timeinfo;  // Zeit Array

String LogFile = "/LogFile0.csv";
int Index = 0;

// Current time
unsigned long currentTime = millis();
// Previous time
unsigned long previousTime = 0; 
// Define timeout time in milliseconds (example: 2000ms = 2s)
const long timeoutTime = 2000;

// Replace with your network credentials
const char* ssid = "Ihr Netzwerk Name";
const char* password = "Netzwerk PW";

String dataString = "";  // LogFile

// Set web server port number to 80
WiFiServer server(80);

// Variable to store the HTTP request
String header;

void setup()
{
  Wire.begin();
  Serial.begin(115200);  // ARDUINO IDE Monitor
  delay(100);
  Serial1.begin(9600, SERIAL_8N1, RXD2, TXD2);  // IR Eingang
  Serial.println("Read Ir start ..");
  
  pinMode(DigOut,OUTPUT);    // Aktivitaets LED
  digitalWrite(DigOut, LOW); //LED aus
               
  //Begin display
  display.init();
  display.flipScreenVertically();
  display.setFont(ArialMT_Plain_16);
  display.setTextAlignment(TEXT_ALIGN_LEFT);
  display.drawString(0,0, "     Smart-Meter");
  display.drawString(0,30,"   Warte auf Netz");
  display.display();

  Time2=millis();   // Zeitstempel
  Test2=0;  // Speicher Schutz initialisieren

  Serial.println("Mounting SD Card...");
  if (SD.begin(SD_CS)) // Test SD-Card
   {
    Serial.println("SD-Card OK");
   }
  else
  {
    Serial.println("SD Card Monting Failed");  // Programm aber nicht beenden
    display.clear();
    display.flipScreenVertically();
    display.setFont(ArialMT_Plain_16);
    display.setTextAlignment(TEXT_ALIGN_LEFT);
    display.drawString(0,0, "     Smart-Meter");
    display.drawString(0,30," Fehler SD-Karte!");
    display.display();
    delay(2000);
  }
 
  // Connect to Wi-Fi network with SSID and password
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) 
  {
    delay(500);
    Serial.print(".");
  }
  // Print local IP address and start web server
  Serial.println("");
  Serial.println("WiFi connected.");
  Serial.println("IP address: ");
  String ip = WiFi.localIP().toString();
  Serial.println(ip);

  setClock(); // Uhrzeit holen

  display.clear();
  display.setFont(ArialMT_Plain_16);
  display.setTextAlignment(TEXT_ALIGN_LEFT);
  display.drawString(0,0, "     Smart-Meter");
  display.drawString(0,20,"  Warte auf Daten");
  display.drawString(5,40,ip);
  display.display();
  
  server.begin(); // WEB Server starten
}

void setClock() // Uhrzeit laden
 {
  configTime(0, 0, "pool.ntp.org");

  Serial.print(F("Waiting for NTP time sync: "));
  time_t nowSecs = time(nullptr);

  while (nowSecs < 8 * 3600 * 2) 
   {
    delay(500);
    Serial.print(F("."));
    yield();
    nowSecs = time(nullptr);
   }
   
  Serial.println();
  
  //struct tm timeinfo;
  gmtime_r(&nowSecs, &timeinfo);  //GMT Zeit
  Serial.print(F("Current time: "));
  Serial.println(asctime(&timeinfo));
  Serial.print(timeinfo.tm_hour);
  Serial.print(":");
  Serial.print(timeinfo.tm_min);
  Serial.print(":");
  Serial.println(timeinfo.tm_sec);
 }

// Convert Hex Byte to ASCII Character

char HexToChar(unsigned char ZZ)
 {
  if(ZZ==00) return '0';
  if(ZZ==01) return '1';
  if(ZZ==02) return '2';
  if(ZZ==03) return '3';
  if(ZZ==04) return '4';
  if(ZZ==05) return '5';
  if(ZZ==06) return '6';
  if(ZZ==07) return '7';
  if(ZZ==0x8) return '8';
  if(ZZ==0x9) return '9';
  if(ZZ==0xA) return 'A';
  if(ZZ==0xB) return 'B';
  if(ZZ==0xC) return 'C';
  if(ZZ==0xD) return 'D';
  if(ZZ==0xE) return 'E';
  if(ZZ==0xF) return 'F';
 }

// Converting from Hex to Decimal long
// (c)2013 BenRugg MIT License (see github.com)

long hexToDec(String hexString) 
 { 
  long decValue = 0;
  int nextInt;
  
  for (int i = 0; i < hexString.length(); i++) 
   {   
    nextInt = int(hexString.charAt(i));
    if (nextInt >= 48 && nextInt <= 57) nextInt = map(nextInt, 48, 57, 0, 9);
    if (nextInt >= 65 && nextInt <= 70) nextInt = map(nextInt, 65, 70, 10, 15);
    if (nextInt >= 97 && nextInt <= 102) nextInt = map(nextInt, 97, 102, 10, 15);
    nextInt = constrain(nextInt, 0, 15);   
    decValue = (decValue * 16) + nextInt;
   } 
  return decValue;
 }

void LogDaten()  // Daten auf die Speicherkarte schreiben
{
     LogFile="/LogFile";
     LogFile+=(String(Index));
     LogFile+=".csv";
     File Logfile = SD.open(LogFile,FILE_WRITE);
     if (Logfile) 
     {
     Logfile.println(String(dataString));
     Logfile.close();
     }
     Serial.println(LogFile);
}

void loop()
{   
  // Server Part erweitert von Peter Klingbeil
  
  /*********
  Rui Santos
  Complete project details at https://randomnerdtutorials.com  
  https://randomnerdtutorials.com/esp32-web-server-arduino-ide/
  *********/
  
  WiFiClient client = server.available();   // Listen for incoming clients
   if (client) 
  {                                         // If a new client connects,
    currentTime = millis();
    previousTime = currentTime;
    Serial.println("New Client.");          // print a message out in the serial port
    String currentLine = "";                // make a String to hold incoming data from the client
    while (client.connected() && currentTime - previousTime <= timeoutTime) 
    {  // loop while the client's connected
      currentTime = millis();
      if (client.available()) 
      {                                     // if there's bytes to read from the client,
        char c = client.read();             // read a byte, then
        Serial.write(c);                    // print it out the serial monitor
        header += c;
        if (c == '\n') 
        {                                   // if the byte is a newline character
          // if the current line is blank, you got two newline characters in a row.
          // that's the end of the client HTTP request, so send a response:
          if (currentLine.length() == 0) 
          {
            // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
            // and a content-type so the client knows what's coming, then a blank line:
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println("Connection: close");
            client.println("Refresh: 10\r\n");   // refresh the page automatically every 10 sec 
            client.println();
                      
            // Display the HTML web page
            client.println("<!DOCTYPE html><html>");
            client.println("<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">");
            client.println("<link rel=\"icon\" href=\"data:,\">");
            
            // CSS to style buttons for later use
            // Feel free to change the background-color and font-size attributes to fit your preferences
            client.println("<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}");
            client.println(".button { background-color: #4CAF50; border: none; color: white; padding: 16px 40px;");
            client.println("text-decoration: none; font-size: 30px; margin: 2px; cursor: pointer;}");
            client.println(".button2 {background-color: #555555;}</style></head>");
            
            // Web Page Heading
            client.println("<body><h1>ESP32 Smart Meter</h1>");
            
            // Display Power
            ZW1=KWH/10000;  // Dezimalpunkt besteimmen
            
            if(Start==0)  // Warte auf gueltige Werte
            {
              client.print("Warte auf Daten");
              client.println("</body></html>");
              client.println();
            }
            else
            {
            client.print("Verbrauch");
            client.print("<h2>");
            client.print(ZW1,DEC);
            client.print(" KWh" "</h2>");                    
 
            client.print("Wirkleistung");
            client.print("<h2>");
            client.print(P,DEC);
            client.print(" Watt" "</h2>");                         
            client.println("</body></html>");
            
            // The HTTP response ends with another blank line
            client.println();
            }
            // Break out of the while loop
            break;
          } 
           else         
          { // if you got a newline, then clear currentLine
            currentLine = "";
          }
        } 
         else if (c != '\r') 
          {  // if you got anything else but a carriage return character,
          currentLine += c;      // add it to the end of the currentLine
          }
      }
    }
    // Clear the header variable
    header = "";
    // Close the connection
    client.stop();
    Serial.println("Client disconnected.");
    Serial.println("");
  }

  // Data Part
  if (Serial1.available())     //IR Daten
  {
    digitalWrite(DigOut, LOW); //LED aus
    inByte = Serial1.read();
    //if (inByte < 0x10)Serial.write('0');
    //Serial.print(inByte,HEX);
    //Serial.write (' ');
    if (inByte == 27) SML++; else SML=0; // Hex 1B 1B 1B 1B, SML Nachricht Start und Ende Sequenz
   }
    if (SML == 4) // SML Data
    {
     while (Counter < 300)
     {
      if (Serial1.available()) 
      {
       
       inByte = Serial1.read();
       //if (inByte < 0x10)Serial.write('0');
       //Serial.print(inByte,HEX);
       //Serial.write ('-');
       Data[Counter++]=inByte; // SML Datensatz einlesen
      }
    }
   Counter = 0;
   delay(150);
   digitalWrite(DigOut, HIGH); //LED an
  }

 if (SML==4)   // Datensatz empfangen
 { 
  SML=0;  // Reset SML Data Block Flag
  for (int x=0; x<290; x++)
  {
    if (Data[x]==82 && Data[x+1]==255 && Data[x+2]==101)
    {
    Time=millis();   // Zeitstempel
    Serial.println("");
    Serial.print("KWh gefunden: ");
    Value[0]=Data[x+3];
    Value[1]=Data[x+4];
    Value[2]=Data[x+5];
    Value[3]=Data[x+6];

    Z=Value[0]&240;
    Z=Z>>4;
    Val[0]=HexToChar(Z);
    Z=Value[0]&15;
    Val[1]=HexToChar(Z);     
    

    Z=Value[1]&240;
    Z=Z>>4;
    Val[2]=HexToChar(Z);
    Z=Value[1]&15;
    Val[3]=HexToChar(Z);     
    

    Z=Value[2]&240;
    Z=Z>>4;
    Val[4]=HexToChar(Z);
    Z=Value[2]&15;
    Val[5]=HexToChar(Z);    
    

    Z=Value[3]&240;
    Z=Z>>4;
    Val[6]=HexToChar(Z);
    Z=Value[3]&15;
    Val[7]=HexToChar(Z);     

    Val[8]='\0';

    Serial.print(" ");
    Serial.print(Val[0]);
    Serial.print(Val[1]);   
    Serial.print(Val[2]);
    Serial.print(Val[3]);
    Serial.print(Val[4]);
    Serial.print(Val[5]);
    Serial.print(Val[6]);
    Serial.print(Val[7]);

    KWH=hexToDec(Val);
    delay(100); // Messinterval etwas verzoegern
    Zyklus++;

    // aktuellen Verbrauch aus den Verbrauchs-Daten berechnen
    DTime=Time-Time2;
    Power=(KWH-KWHalt) * (360000/(DTime));
    KWHakku=KWHakku + Power;
    
    KWHalt=KWH;
    Time2=Time;
   
    //KWh anzeigen HEX
    if(Zyklus == 8)
    {
     Power = KWHakku / 8;  // Mittelwert bilden
     if (Start==1)
     {
     P=Power; // WEB 
     display.clear();
     display.flipScreenVertically();
     display.setFont(ArialMT_Plain_24);
     display.setTextAlignment(TEXT_ALIGN_LEFT);
     display.drawString(40,25,String(Power));
     display.display();

     setClock(); // Uhrzeit holen
     dataString += String(timeinfo.tm_hour);
     dataString += String(":");
     dataString += String(timeinfo.tm_min);
     dataString += String(":");
     dataString += String(timeinfo.tm_sec);
     //dataString +=(asctime(&timeinfo));
     dataString += String(";");
     dataString += String(Power);
     dataString += String("\n");
     Test++;  // Ein Datensatz geschrieben
     }
     
     if(Test = 10) //  Log Datei schreiben
     {
      LogDaten();
      Test=0;
      Test2++;
     }

     if(Test2 > 450)  // 2 Stunden
     {
      Test2=0;
      setClock(); // Uhrzeit holen
      dataString=(asctime(&timeinfo));  // Datum an den Anfang der neuen Log Datei
      dataString+="\n";
      Index++;
     }
        
     Zyklus=0;
     KWHakku=0;
     Start=1;  // ab jetzt ist Power gueltig
    }    
    x=290;  // Datensatz Laenge max.
     }
   }
  }
}
